OpenShot Audio Library | OpenShotAudio: juce::MPENote Struct Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
juce::MPENote Struct Reference

`#include <juce_MPENote.h>`

## Public Types
enum | KeyState { off = 0 , keyDown = 1 , sustained = 2 , keyDownAndSustained = 3 }

## Public Member Functions
| MPENote (int midiChannel, int initialNote, MPEValue velocity, MPEValue pitchbend, MPEValue pressure, MPEValue timbre, KeyState keyState=MPENote::keyDown) noexcept
| MPENote () noexcept
bool | isValid () const noexcept
double | getFrequencyInHertz (double frequencyOfA=440.0) const noexcept
bool | operator== (const MPENote &other) const noexcept
bool | operator!= (const MPENote &other) const noexcept

## Public Attributes
uint16 | noteID = 0
uint8 | midiChannel = 0
uint8 | initialNote = 0
MPEValue | noteOnVelocity { MPEValue::minValue() }
MPEValue | pitchbend { MPEValue::centreValue() }
MPEValue | pressure { MPEValue::centreValue() }
MPEValue | initialTimbre { MPEValue::centreValue() }
MPEValue | timbre { MPEValue::centreValue() }
MPEValue | noteOffVelocity { MPEValue::minValue() }
double | totalPitchbendInSemitones
KeyState | keyState { MPENote::off }

## Detailed Description

This struct represents a playing MPE note.

A note is identified by a unique ID, or alternatively, by a MIDI channel and an initial note. It is characterised by five dimensions of continuous expressive control. Their current values are represented as MPEValue objects.

See also
  MPEValue

Definition at line 39 of file juce_MPENote.h.

## Member Enumeration Documentation

## ◆ KeyState

enum juce::MPENote::KeyState

Possible values for the note key state.

Enumerator
off | The key is up (off).
keyDown | The note key is currently down (pressed).
sustained | The note is sustained (by a sustain or sostenuto pedal).
keyDownAndSustained | The note key is down and sustained (by a sustain or sostenuto pedal).

Definition at line 43 of file juce_MPENote.h.

## Constructor & Destructor Documentation

## ◆ MPENote() [1/2]

juce::MPENote::MPENote | ( | int | midiChannel,
|  | int | initialNote,
|  | MPEValue | velocity,
|  | MPEValue | pitchbend,
|  | MPEValue | pressure,
|  | MPEValue | timbre,
|  | KeyState | keyState = MPENote::keyDown )
| noexcept

Constructor.

Parameters

  midiChannel | The MIDI channel of the note, between 2 and 15. (Channel 1 and channel 16 can never be note channels in MPE).
  initialNote | The MIDI note number, between 0 and 127.
  velocity | The note-on velocity of the note.
  pitchbend | The initial per-note pitchbend of the note.
  pressure | The initial pressure of the note.
  timbre | The timbre value of the note.
  keyState | The key state of the note (whether the key is down and/or the note is sustained). This value must not be MPENote::off, since you are triggering a new note. (If not specified, the default value will be MPENote::keyDown.)

Definition at line 38 of file juce_MPENote.cpp.

## ◆ MPENote() [2/2]

juce::MPENote::MPENote | ( |  | ) |
| noexcept

Default constructor.

Constructs an invalid MPE note (a note with the key state MPENote::off and an invalid MIDI channel. The only allowed use for such a note is to call isValid() on it; everything else is undefined behaviour.

Definition at line 59 of file juce_MPENote.cpp.

## Member Function Documentation

## ◆ getFrequencyInHertz()

double juce::MPENote::getFrequencyInHertz | ( | double | frequencyOfA = 440.0 | ) | const
| noexcept

Returns the current frequency of the note in Hertz. This is the sum of the initialNote and the totalPitchbendInSemitones, converted to Hertz.

Definition at line 68 of file juce_MPENote.cpp.

## ◆ isValid()

bool juce::MPENote::isValid | ( |  | ) | const
| noexcept

Checks whether the MPE note is valid.

Definition at line 62 of file juce_MPENote.cpp.

Referenced by juce::MPESynthesiser::findVoiceToSteal().

## ◆ operator!=()

bool juce::MPENote::operator!= | ( | const MPENote & | other | ) | const
| noexcept

Returns true if two notes are different notes, determined by their unique ID.

Definition at line 81 of file juce_MPENote.cpp.

## ◆ operator==()

bool juce::MPENote::operator== | ( | const MPENote & | other | ) | const
| noexcept

Returns true if two notes are the same, determined by their unique ID.

Definition at line 75 of file juce_MPENote.cpp.

## Member Data Documentation

## ◆ initialNote

uint8 juce::MPENote::initialNote = 0

The MIDI note number that was sent when the note was triggered. This should never change during the lifetime of an MPENote object.

Definition at line 108 of file juce_MPENote.h.

Referenced by juce::MPESynthesiser::findVoiceToSteal(), and isValid().

## ◆ initialTimbre

MPEValue juce::MPENote::initialTimbre { MPEValue::centreValue() }

Initial value of timbre when the note was triggered. This should never change during the lifetime of an MPENote object.

Definition at line 138 of file juce_MPENote.h.

## ◆ keyState

KeyState juce::MPENote::keyState { MPENote::off }

Current key state. Indicates whether the note key is currently down (pressed) and/or the note is sustained (by a sustain or sostenuto pedal).

Definition at line 169 of file juce_MPENote.h.

Referenced by juce::MPESynthesiser::findVoiceToSteal(), and juce::MPESynthesiserVoice::isPlayingButReleased().

## ◆ midiChannel

uint8 juce::MPENote::midiChannel = 0

The MIDI channel which this note uses. This should never change during the lifetime of an MPENote object.

Definition at line 103 of file juce_MPENote.h.

Referenced by isValid().

## ◆ noteID

uint16 juce::MPENote::noteID = 0

A unique ID. Useful to distinguish the note from other simultaneously sounding notes that may use the same note number or MIDI channel. This should never change during the lifetime of a note object.

Definition at line 98 of file juce_MPENote.h.

## ◆ noteOffVelocity

MPEValue juce::MPENote::noteOffVelocity { MPEValue::minValue() }

The release velocity ("lift") of the note after a note-off has been received. This dimension will only have a meaningful value after a note-off has been received for the note (and keyState is set to MPENote::off or MPENote::sustained). Initially, the value is undefined.

Definition at line 152 of file juce_MPENote.h.

## ◆ noteOnVelocity

MPEValue juce::MPENote::noteOnVelocity { MPEValue::minValue() }

The velocity ("strike") of the note-on. This dimension will stay constant after the note has been turned on.

Definition at line 116 of file juce_MPENote.h.

## ◆ pitchbend

MPEValue juce::MPENote::pitchbend { MPEValue::centreValue() }

Current per-note pitchbend of the note (in units of MIDI pitchwheel position). This dimension can be modulated while the note sounds.

Note: This value is not aware of the currently used pitchbend range, or an additional master pitchbend that may be simultaneously applied. To compute the actual effective pitchbend of an MPENote, you should probably use the member totalPitchbendInSemitones instead.

See also
  totalPitchbendInSemitones, getFrequencyInHertz

Definition at line 128 of file juce_MPENote.h.

Referenced by juce::MPEInstrument::MPEInstrument().

## ◆ pressure

MPEValue juce::MPENote::pressure { MPEValue::centreValue() }

Current pressure with which the note is held down. This dimension can be modulated while the note sounds.

Definition at line 133 of file juce_MPENote.h.

Referenced by juce::MPEInstrument::MPEInstrument().

## ◆ timbre

MPEValue juce::MPENote::timbre { MPEValue::centreValue() }

Current value of the note's third expressive dimension, typically encoding some kind of timbre parameter. This dimension can be modulated while the note sounds.

Definition at line 144 of file juce_MPENote.h.

Referenced by juce::MPEInstrument::MPEInstrument().

## ◆ totalPitchbendInSemitones

double juce::MPENote::totalPitchbendInSemitones

Current effective pitchbend of the note in units of semitones, relative to initialNote. You should use this to compute the actual effective pitch of the note. This value is computed and set by an MPEInstrument to the sum of the per-note pitchbend value (stored in MPEValue::pitchbend) and the master pitchbend of the MPE zone, weighted with the per-note pitchbend range and master pitchbend range of the zone, respectively.

See also
  getFrequencyInHertz

Definition at line 164 of file juce_MPENote.h.

The documentation for this struct was generated from the following files:

- juce_MPENote.h
- juce_MPENote.cpp